<template>
  <!-- <p> -->
  <!--   <button @click="showModal"> -->
  <!--     Show modal -->
  <!--   </button> -->
  <!-- </p> -->
  <Modal
    v-if="isShow"
    v-slot="{ emitClose }"
    :close="closeModal"
  >
    <div class="modal">
      <button @click="emitClose">
        cerrar
      </button>
      <p>
        Código generado para tarjeta NodeMCU
      </p>
      <p class="classMessage">
      {{ message }}
      </p>
    </div>
  </Modal>
</template>

<script lang="ts">
import { defineComponent, ref, watch, onMounted } from 'vue'

export default defineComponent({
  // props: {
  //  message: {
  //    type: string,
  //    default: 'mi mensaje'
  //  }
  // },
  props: ['parentMessage', 'trigger'],
  setup (props) {
    const isShow = ref(false)
    const message = ref()

    function showModal () {
      isShow.value = true
    }

    function closeModal () {
      isShow.value = false
    }

    watch(() => props.trigger, (msg, oldMsg) => {
      message.value = props.parentMessage
      console.log('watch: ', 'trigger value actual: ', msg, '\ntrigger value old: ', oldMsg, '\nthis message_: ', message.value)
      // console.log(props.parentMessage)
      showModal()
    })

    onMounted(() => {
      // console.log(props.parentMessage)
    })

    return {
      isShow,
      showModal,
      closeModal,
      message
    }
  }
})
</script>

<style>
.modal {
  width: auto;
  /* width: 300px;*/
  padding: 10px;
  box-sizing: border-box;
  background-color: #fff;
  font-size: 20px;
  text-align: center;
  position: absolute;
  top: 20px;
  bottom: 20px;
  overflow: scroll;
}
.classMessage {
  height: auto;
  text-align: left;
  white-space: pre; /* habilita \n y \t para <p> */
}
.vue-universal-modal {
  z-index: 71;
}
</style>
